# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

#%bcond_without test
%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/jboss/jboss-man/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define reltag SP2
%define namedversion %{version}.%{reltag}

Name:           jboss-man
Version:        2.1.1
Release:        4.%{reltag}.6%{?dist}
Epoch:          0
Summary:        JBoss Man
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/jboss-man/tags/2.1.1.SP2/ jboss-man-2.1.1 && tar cjf jboss-man-2.1.1.SP2.tar.bz2 jboss-man-2.1.1
# Exported Revision 105228.
Source0:        jboss-man-2.1.1.SP2.tar.bz2
Source1:        jboss-man-jpp-depmap.xml
Source2:        jboss-man-settings.xml
Source3:        jboss-man-component-info.xml
Patch0:         jboss-man-pom.patch
Patch1:         %{name}-jaxb_api.patch

BuildArch:      noarch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BUildRequires:  maven-deploy-plugin
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  ant-junit
BuildRequires:	dtdparser
BuildRequires:  eap5-boms
BuildRequires:  javassist
BuildRequires:  jaxb_2_1_api
BuildRequires:  jboss-common-logging-log4j
BuildRequires:  jboss-profiler
BuildRequires:  jboss-test
BuildRequires:  jboss-common-core
BuildRequires:  jboss-common-logging-spi
BuildRequires:  jboss-mdr
BuildRequires:  jboss-parent
BuildRequires:  jboss-reflect
BuildRequires:  junit4
BuildRequires:  log4j
BuildRequires:  pom-version-manipulator
BuildRequires:  qdox
BuildRequires:	xml-commons-jaxp-1.3-apis

Requires:  jboss-common-core
Requires:  jboss-common-logging-spi
Requires:  jboss-mdr
Requires:  jboss-reflect

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss managed and metatype.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm} -f

# Adjust pom.xml
%{_bindir}/modpom pom.xml %{_javadir}/jbossas/jboss-as-component-matrix.pom
mv %{name}-parent-%{namedversion}.pom pom.xml
sed -i 's/Name>jboss-man-parent/Name>${artifactId}/g' pom.xml
%{_bindir}/modpom build/pom.xml %{_javadir}/jbossas/jboss-as-component-matrix.pom
%{_bindir}/modpom managed/pom.xml %{_javadir}/jbossas/jboss-as-component-matrix.pom
sed -i 's/sun-jaxb/javax.xml.bind/g' managed/pom.xml
%{_bindir}/modpom metatype/pom.xml %{_javadir}/jbossas/jboss-as-component-matrix.pom

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.skip \
        -Dskip-enforce \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        install deploy:deploy

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Daggregate=true \
        -Dmaven.test.skip \
        -Dskip-enforce \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 metatype/target/jboss-metatype.jar $RPM_BUILD_ROOT%{_javadir}/jboss-metatype-%{version}.jar
install -m 644 metatype/target/jboss-metatype-sources.jar $RPM_BUILD_ROOT%{_javadir}/jboss-metatype-%{version}-sources.jar
install -m 644 managed/target/jboss-managed.jar $RPM_BUILD_ROOT%{_javadir}/jboss-managed-%{version}.jar
install -m 644 managed/target/jboss-managed-sources.jar $RPM_BUILD_ROOT%{_javadir}/jboss-managed-%{version}-sources.jar
#install -m 644 managed/target/jboss-managed-api.jar $RPM_BUILD_ROOT%{_javadir}/jboss-managed-api-%{version}.jar
#install -m 644 managed/target/jboss-managed-plugins.jar $RPM_BUILD_ROOT%{_javadir}/jboss-managed-plugins-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-parent.pom
%add_to_maven_depmap org.jboss.man %{name}-parent %{namedversion} JPP %{name}-parent
install -m 644 metatype/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-jboss-metatype.pom
%add_to_maven_depmap org.jboss.man jboss-metatype %{namedversion} JPP jboss-metatype
install -m 644 managed/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-jboss-managed.pom
%add_to_maven_depmap org.jboss.man jboss-managed %{namedversion} JPP jboss-managed

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -rf target/site/apidocs/* \
                  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -p -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/jboss-managed.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-managed.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/jboss-managed-sources.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-managed-sources.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/jboss-metatype.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-metatype.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/jboss-metatype-sources.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-metatype-sources.jar
cp -p pom.xml $RPM_BUILD_ROOT%{repodirlib}/jboss-man-parent.pom
cp -p metatype/pom.xml $RPM_BUILD_ROOT%{repodirlib}/jboss-metatype.pom
cp -p managed/pom.xml $RPM_BUILD_ROOT%{repodirlib}/jboss-managed.pom
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/jboss-metatype-%{version}.jar
%{_javadir}*/jboss-metatype.jar
%{_javadir}*/jboss-metatype-%{version}-sources.jar
%{_javadir}*/jboss-metatype-sources.jar
%{_javadir}*/jboss-managed-%{version}.jar
%{_javadir}*/jboss-managed.jar
%{_javadir}*/jboss-managed-%{version}-sources.jar
%{_javadir}*/jboss-managed-sources.jar
%{_datadir}/maven2/poms/JPP-jboss-managed.pom
%{_datadir}/maven2/poms/JPP-jboss-metatype.pom
%{_datadir}/maven2/poms/JPP-%{name}-parent.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Jan 20 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.1.1-4.SP2.6
- Complete fix for jaxb-api including proper dependencies

* Thu Jan 20 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.1.1-4.SP2.5
- Fix jaxb-api groupId in pom.xml files

* Tue Jan 18 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.1.1-4.SP2.4
- Add BR eap5-boms, pom-version-manipulator to adjust pom.xml

* Tue Jan 18 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.1.1-4.SP2.3
- Rebuild for MEAD
- Add BR qdox

* Fri Dec 03 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.1.1-4.SP2.2
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR maven-deploy-plugin, maven-site-plugin
- Change javadoc:javadoc to javadoc:aggregate

* Wed Jun 02 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.1.1-4.SP2.1.1
- Add BR dtdparser, xml-commons-jaxp-1.3-apis

* Tue May 25 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.1.1-4.SP2.1
- Upgrade to 2.1.1.SP2

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.1.1-3.3.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redha.com>  0:2.1.1-3.3
- Rebuild

* Thu Jan 28 2010 Yiqiao Wang <yiwang@redhat.com> 0:2.1.1-3.2.1.1
- Rebuild with dependency to jboss-test (enable test flag)

* Fri Jan 15 2010 Yiqiao Wang <yiwang@redhat.com> 0:2.1.1-3.2.1 
- Add patches to remove dependency for jboss-test 

* Wed Aug 19 2009 David Walluck <dwalluck@redhat.com> 0:2.1.1-3.2
- add poms to repolib

* Tue Aug 18 2009 David Walluck <dwalluck@redhat.com> 0:2.1.1-3.1
- fix Release

* Tue Aug 18 2009 David Walluck <dwalluck@redhat.com> 0:2.1.1-3
- 2.1.1.GA

* Tue Jul 21 2009 Martha Benitez <mbenitez@redhat.com> 0:2.1.1-2.CR1.1
- Upgrade to version 2.1.1.CR1

* Wed Jun 17 2009 David Walluck <dwalluck@redhat.com> 0:2.1.0-2.SP1.1
- 2.1.0.SP1

* Wed Jun 10 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.1.0-1.jpp5
- 2.1.0.GA

* Wed May 27 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.0.0-1.jpp5
- first release

